﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Draw
{
    public partial class DrawWindow : Form
    {
        public DrawWindow()
        {
            InitializeComponent();
            pictureBox_SizeChanged (null, null);
            /*
            int w = pictureBox.Width;
            int h = pictureBox.Height;
            pictureBox.Image = new Bitmap (w, h);

            Graphics g = Graphics.FromImage (pictureBox.Image);
            Brush brush = new SolidBrush (Color.White);
            g.FillRectangle (brush, 0, 0, w, h);

            Pen pen = new Pen(Color.Blue);
            g.DrawLine(pen, 0, 0, 200, 100);
            */
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            Bitmap orig = null;
            if (pictureBox.Image != null)
               orig = new Bitmap (pictureBox.Image);

            int w = pictureBox.Width;
            int h = pictureBox.Height;

            if (orig != null)
            {
                if (w < orig.Width) w = orig.Width;
                if (h < orig.Height) h = orig.Height;
            }

            pictureBox.Image = new Bitmap (w, h);

            Graphics g = Graphics.FromImage(pictureBox.Image);
            Brush brush = new SolidBrush(Color.White);
            g.FillRectangle (brush, 0, 0, w, h);

            if (orig != null)
                g.DrawImage (orig, 0, 0);
        }

        private int X0, Y0;
        private bool click = false;
        private Image save;

        private void pictureBox_MouseDown (object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            click = true;
            save = new Bitmap (pictureBox.Image);
        }

        private void pictureBox_MouseMove (object sender, MouseEventArgs e)
        {
            if (click)
            {
                Graphics g = Graphics.FromImage(pictureBox.Image);
                g.DrawImage (save, 0, 0);
                Pen pen = new Pen (Color.Red, 3);
                Brush brush = new SolidBrush (Color.CornflowerBlue);
                
                // g.DrawLine(pen, X0, Y0, e.X, e.Y);

                // g.FillEllipse (brush, X0, Y0, e.X - X0, e.Y - Y0);
                // g.DrawEllipse (pen, X0, Y0, e.X - X0, e.Y - Y0);

                int X1 = X0;
                int Y1 = Y0;
                int X2 = e.X;
                int Y2 = e.Y;
                if (X1 > X2) { int t = X1; X1 = X2; X2 = t; }
                if (Y1 > Y2) { int t = Y1; Y1 = Y2; Y2 = t; }
                g.FillRectangle (brush, X1, Y1, X2 - X1, Y2 - Y1);
                g.DrawRectangle (pen, X1, Y1, X2 - X1, Y2 - Y1);


                pictureBox.Invalidate();
            }
        }

        private void pictureBox_MouseUp (object sender, MouseEventArgs e)
        {
            click = false;
        }
    }
}
